// D_Skywalk almost lili-code :D
// house specific functions...

extern unsigned char *map_pointer;
extern unsigned char malotes_t;

unsigned int gix, giy, git;
signed int gicx, gicy, gfx, gfy;

void paint_marco (void);

void house_handler(void) {

    switch(n_pant) {
        case 16:
			if(malotes_t & EN_GUY)
			    map_attr [(15 * 5) + 7] = 8;
            break;
        case 20:
			if(malotes_t)
                map_attr [(15 * 7) + 3] = 8; // lo mismo que colored, pero dividido entre 2
			break;
	    case 21:
	        if(!(player.keys & F_PASTI)) {
	            draw_coloured_tile (VIEWPORT_X + 14, VIEWPORT_Y + 8, 0);
	            draw_coloured_tile (VIEWPORT_X + 16, VIEWPORT_Y + 8, 0);
	            draw_coloured_tile (VIEWPORT_X + 14, VIEWPORT_Y +10, 0);
	            draw_coloured_tile (VIEWPORT_X + 16, VIEWPORT_Y +10, 0);
	            sp_UpdateNow();
	        }
	        break;
    }
}

void calc_nextroom(void) {

    switch(n_pant){
        case 17:
            switch(player.facing) {
                case FACING_UP:
                    if(player.keys & F_CHAMPI){
                        --n_pant;
                        player.keys &= ~F_CHAMPI; //pierde el champi
                        recover_pal();
                        paint_marco();
                    }else
                        peta_el_beeper(11);
                    break;
                case FACING_RIGHT:
                    ++n_pant;
                    break;
            }
            break;
        case 20:
            recover_pal();
        default:
            switch(player.facing) {
                case FACING_DOWN:
                    n_pant = (n_pant % 8) + (((n_pant / 8) + 1) * 8);
                    break;
                case FACING_UP:
                    n_pant = (n_pant % 8) + (((n_pant / 8) - 1) * 8);
                    break;
                case FACING_LEFT:
                    --n_pant;
                    break;
                case FACING_RIGHT:
                    ++n_pant;
                    break;
            } 
    }
}


#define MAX_RECORRIDO (6 * 15)
void calc_nextdoor(void) {
    gfy = gix = 0;
    switch(player.facing) {
        case FACING_UP:
            #define DOORS_DOWN_START 7
            giy = DOORS_DOWN_START;
            gicy = -1;
            gicx = 0;
            git = 11; // tile type
            break;
         
        case FACING_DOWN:
            #define DOORS_UP_START 5
            giy = DOORS_UP_START;
            gicy = 1;
            gicx = 0;
            git = 12; // tile type
            gfy = -768; // up tile is upper
            break;
        case FACING_LEFT:
            #define DOORS_RIGHT_START 4
            giy = DOORS_RIGHT_START;
            gicy = 0;
            gicx = -1;
            git = 14; // tile type
            break;
        case FACING_RIGHT:
            #define DOORS_LEFT_START 4
            giy = DOORS_LEFT_START;
            gicy = 0;
            gicx = 1;
            git = 10; // tile type
            break;
    }

    map_pointer = &map_buff [15 * giy];
    do {
        if(*(map_pointer + gix) == git) {
            player.y = ((giy + (gix / 15) + gicy ) << 10) + gfy;
            player.x = (((gix % 15) + gicx) << 10);
            //print_number2 (1, 3, player.y);
            //print_number2 (1, 4, player.x);
            return;
        }
    } while(++gix < MAX_RECORRIDO);
    
    // safe zone
    player.x = 7 << 10;
    player.y = 7 << 10;
    //print_str (1, 1, 39, "OH", FALSE);

}

unsigned char is_door(unsigned char type){
    switch(type){
        case 11:
            player.facing = FACING_DOWN;
            return 1;
        case 12:
            player.facing = FACING_UP;
            return 1;
        case 14:
            player.facing = FACING_RIGHT;
            return 1;
        case 10:
            player.facing = FACING_LEFT;
            return 1;
        default:
            return 0;
    }
}

