#!/bin/bash

GAMENAME=asylum
FIVENAME=ASYLM

# Cambia "%1" por el nombre de tu güego.
rm ../$GAMENAME.tap &> /dev/null
rm -rf build &> /dev/null
mkdir -p build
echo "-----------------------------------"
echo "### REGENERANDO MAPA y SPRITES ###"
#tmxcompress ../map/mapa.tmx ../gfx/work.png build/tmp.tmx build/tmp.png build/mapa_comprimido.bin &> /dev/null
#gentileset.sh
cp mapa_comprimido.bin build/
#TODO: tileset.png to tileset.h
#sprcnv ../gfx/sprites.png sprites.h &> /dev/null
cp -vf ../gfx/loading.scr build/loading.scr
rcs build/loading.scr build/loading.rcs
zx7 build/loading.rcs build/loading.bin
apack ../gfx/title.scr build/title.bin | head -1
apack ../gfx/marco.scr build/marco.bin | head -1
apack ../gfx/combat.scr build/combat.bin | head -1
apack ../gfx/ending.scr build/ending.bin | head -1
echo " "
echo "########################"
echo "### COMPILANDO GUEGO ###"
cd build
zcc +zx -vn ../$GAMENAME.c -o $GAMENAME.bin -lndos -lsplib2 -zorg=24200

echo "##########################"
echo "### CONSTRUYENDO CINTA ###"
zx7 $GAMENAME.bin $GAMENAME.zx7
# compressor and loader
sjasmplus ../../lib/dzx7_smartRCS.asm | tail -1 # gen dzx7.bin
printf -v TAMANO %x `wc -c < asylum.zx7`
echo " define COMP_SIZE \$$TAMANO " > define.asm
sjasmplus ../../lib/asmloader.asm |tail -1 # gen asmloader.bin
#final tape
gentape ../../$GAMENAME.tap \
    basic "'ASYLUM'" 0 asmloader.bin \
    data               $GAMENAME.zx7

echo "### DONE ###"
TAMANO=`wc -c < $GAMENAME.bin`
TAMANO=`expr $TAMANO + 2` # add header
TOTAL=`expr $TAMANO + 24200`
ZXWEIGHT=`expr 60654 - $TOTAL`
echo "$TAMANO + 24200 = $TOTAL ( $ZXWEIGHT )"
cd ..

